
#include <iostream>
#include <ell/EnergyFunction.hh>


int main(int argc, char **argv) {

	using namespace ell;

	std::cout	<<"========== BEGIN OF TEST =================\n"
				<<" test class : ContactEnergyFunction\n"
				<<"==========================================" <<std::endl;
				
		// erzeugen	
	std::cout <<"=> creating ell::Alphabet(HPNX,1) = alph" <<std::endl;
	Alphabet alph("HPNX",1);
	std::cout <<"=> creating ell::EnergyMatrix(0.0,4,4) = E" <<std::endl;
	EnergyMatrix E = EnergyMatrix(	0.0, 
									alph.getAlphabetSize(),
									alph.getAlphabetSize());
		E[alph.getIndex("H")][alph.getIndex("H")] = -4.0;
		E[alph.getIndex("P")][alph.getIndex("P")] =  1.0;
		E[alph.getIndex("N")][alph.getIndex("N")] =  1.0;
		E[alph.getIndex("P")][alph.getIndex("N")] = -1.0;
		E[alph.getIndex("N")][alph.getIndex("P")] = -1.0;
	std::cout <<E <<std::endl;
	std::cout <<"=> creating ell::ContactEnergyFunction( alph, E)" <<std::endl;
	ContactEnergyFunction f(&alph, &E);
	
		// getAlphabet()
	std::cout	<<"->getAlphabet()->getAlphabetSize() = " 
				<<f.getAlphabet()->getAlphabetSize() 
				<<std::endl;
	
		// getContactEnergy()
	std::cout <<"->getContactEnergy( 0..3, 0..3)" <<std::endl;
	EnergyMatrix T = EnergyMatrix(-1.0, E.numRows(), E.numColumns());
	for (unsigned int i = 0; i<alph.getAlphabetSize(); i++) {
		for (unsigned int j = 0; j<alph.getAlphabetSize(); j++) {
			std::cout <<f.getContactEnergy(	alph.getElement(i), 
											alph.getElement(j)) <<" ";
		}
		std::cout <<std::endl;
	}

		// ==
	std::cout	<<"-> (*this == *this) = " 
				<<(f == f?"true":"false")
				<<std::endl;

		// !=
	std::cout	<<"-> (*this != *this) = " 
				<<(f != f?"true":"false")
				<<std::endl;

	std::cout	<<"============= END OF TEST ================\n" <<std::endl;
	
	return 0;
}
