

#include <iostream>
#include <ell/NeighborVector.hh>


int main(int argc, char **argv) {

	using namespace ell;

	std::cout	<<"========== BEGIN OF TEST =================\n"
				<<" test class : NeighborVector\n"
				<<"==========================================" <<std::endl;
				
		// erzeugen	
	std::cout <<"=> creating ell::MoveAlphabet(FBLR,1)" <<std::endl;
	MoveAlphabet alph = MoveAlphabet("FBLR",1);
	std::cout <<"=> creating ell::Automorphism({{1,0,0},{0,1,0},{0,0,1}})"
				<<" = a2r" <<std::endl;
	Automorphism a2r = Automorphism((int[3][3]){{1,0,0},{0,1,0},{0,0,1}});
	std::cout <<"=> creating a2r*2 = r2a" <<std::endl;
	Automorphism r2a = a2r * 2;
	std::cout <<"=> creating ell::NeighborVector(1,0,0, alph.getElement(B)"
				<<", r2a, a2r)" <<std::endl;
	NeighborVector nv = NeighborVector(-1,0,0, alph.getElement("B"), r2a, a2r);
	
		// getX()
	std::cout	<<"->getX()  = "  << nv.getX() <<std::endl;

		// getY()
	std::cout	<<"->getY()  = " << nv.getY() <<std::endl;

		// getZ()
	std::cout	<<"->getZ()  = "  << nv.getZ() <<std::endl;

		// getMove()
	std::cout	<<"->alph.getString(getMove())  = " 
				<< alph.getString(nv.getMove())
				<<std::endl;

		// getAbs2RelRotation()
	std::cout	<<"->getAbs2RelRotation()  = \n"  << nv.getAbs2RelRotation();
	std::cout.flush();
	
		// getRel2AbsRotation()
	std::cout	<<"->getRel2AbsRotation()  = \n"  << nv.getRel2AbsRotation();
	std::cout.flush();
	
		// operator ==
	std::cout	<<"->this == IntPoint(-1,0,0)  = " 
				<< (nv == IntPoint(-1,0,0)?"true":"false")
				<<std::endl;
	
	
	
	std::cout	<<"============= END OF TEST ================\n" <<std::endl;
	
	return 0;
}
