

#include <iostream>
#include <ell/RNAFreeEnergySingleMoveState.hh>

#include <time.h>
int main(int argc, char **argv) {

	using namespace ell;

	std::cout	<<"========== BEGIN OF TEST ==================\n"
				<<" test class : RNAFreeEnergySingleMoveState\n"
				<<"===========================================" <<std::endl;
				
		// erzeugen	
	srandom( (unsigned) time(NULL) );

	std::cout	<<"=> create ell::Alphabet(ACGU,1) = alph" <<std::endl;
		ell::Alphabet* alph = new ell::Alphabet("ACGU", 1);
	std::cout	<<"=> create base pair set { AU, GU, CG } = bpSet" <<std::endl;
		std::set< std::pair<std::string,std::string> > bpSet;
		bpSet.insert(std::pair<std::string,std::string>("A","U"));
		bpSet.insert(std::pair<std::string,std::string>("G","U"));
		bpSet.insert(std::pair<std::string,std::string>("C","G"));
	std::cout	<<"=> create ell::AllowedBasePairs(alph, bpSet) = bp" 
				<<std::endl;
		ell::AllowedBasePairs* bp = new ell::AllowedBasePairs(alph, bpSet);
		std::string seqStr = "GGCAAAGUCAAAGAU";
	std::cout	<<"=> " <<seqStr <<" = seqStr" <<std::endl;
		std::string structStr = "..(...).(...)..";
	std::cout	<<"=> " <<structStr <<" = structStr" <<std::endl;
	std::cout	<<"=> create ell::RNAFreeEnergySingleMoveState(seqStr,"
				<<" structStr, bp)" <<std::endl;
	ell::RNAFreeEnergySingleMoveState rnaStruct(seqStr, structStr, bp);

		// getStateStringRepresentation()
	std::cout	<<"->getStateStringRepresentation()  = "
				<<rnaStruct.getStateStringRepresentation()
				<<std::endl;

		// getFitness()
	std::cout	<<"->getFitness()  = "
				<<(rnaStruct.getFitness())
				<<std::endl;

	ell::State* rnaStruct2 = rnaStruct.clone();

		// clone()  ==
	std::cout	<<"->(*this == *(this->clone()))  = "
				<<(rnaStruct == *rnaStruct2 ? "true":"false")
				<<std::endl;

		// clone()  !=
	std::cout	<<"->(*this != *(this->clone()))  = "
				<<(rnaStruct != *rnaStruct2 ? "true":"false")
				<<std::endl;

		// clone() <
	std::cout	<<"->(*this < *(this->clone()))  = "
				<<(rnaStruct < *rnaStruct2 ? "true":"false")
				<<std::endl;

	std::cout	<<"=> create ell::RNAFreeEnergySingleMoveState("
				<<"\"AGCAAAGUCAAAGAU\",seqStr, bp) = rnaStruct3" <<std::endl;
		ell::RNAFreeEnergySingleMoveState rnaStruct3("AGCAAAGUCAAAGAU",
		structStr, bp);
		std::cout	<<"->(rnaStruct3 < *(this->clone()))  = "
				<<(rnaStruct3 < *rnaStruct2 ? "true":"false")
				<<std::endl;

	int num = 0;
	
	ell::State::NeighborListPtr nl = rnaStruct.getNeighborList();
	ell::State::NeighborList::Iterator it = nl->begin();
	std::set<std::string> neighs, randneighs;
	std::set<std::string>::const_iterator setIt;
	std::cout	<<"->getNeighborList()  ==> now sorted" <<std::endl;
	for(it = nl->begin(); it != nl->end(); ++it) {
		neighs.insert(it->getStateStringRepresentation());
	}
	for(setIt = neighs.begin(); setIt != neighs.end(); setIt++) {
		std::cout <<" " <<++num <<"\t: " <<*setIt <<std::endl;
	}
				
	num = 0;
	nl = rnaStruct.getRandomNeighborList();
	std::cout	<<"->getRandomNeighborList() ==> now sorted" <<std::endl;
	for(it = nl->begin(); it != nl->end(); ++it) {
		randneighs.insert(it->getStateStringRepresentation());
	}
	for(setIt = randneighs.begin(); setIt != randneighs.end(); setIt++) {
		std::cout <<" " <<++num <<"\t: " <<*setIt <<std::endl;
	}

	std::cout	<<"Distance to GGCAAAGUCAAAGAU (.((...)....).): "
				<<rnaStruct.getMinimalDistance(
					ell::RNAFreeEnergySingleMoveState(	"GGCAAAGUCAAAGAU", 
														"(.((...)....).)", bp))
				<<std::endl;

	delete alph;
	delete bp;
	
	delete rnaStruct2;
	
	std::cout	<<"============= END OF TEST =================\n" <<std::endl;
	
	return 0;
}
